<?
include("ApiGlobalFunctions.php");

$usuario=$_POST['uid'];
$password=$_POST['key'];
$url=$_POST['url'];
$slotID=$_POST['slotID'];
$qty=$_POST['qty'];
$serieBI=$_POST['NSerie'];

$include=includec($url);
include ($include);
$validate=loginkey($usuario,$password,$url);

if($validate==1){   
    $lote=diccionario($url,'LoteB');
    $cantasset=diccionario($url,'QtyAsset');
    $fingreso=diccionario($url,'FIngresoB');
    $BodAsset=diccionario($url,'BodAsset');
    $SlotAsset=diccionario($url,'SlotAsset');
    $SeccAsset=diccionario($url,'SeccAsset');
    $RackAsset=diccionario($url,'RackAsset');
    $MovAsset=diccionario($url,'MovAsset');
    $UltInv=diccionario($url,'UltInv');
    $MovAsset=diccionario($url,'MovAsset');

    $asignado="19x".$usuario;

    $query=mysqli_query($link,"SELECT crmid,slotsid,slots_tks_codigo, bodegas_tks_nombre, secciones_tks_seccion, racks_tks_rack 
    FROM vtiger_slots 
    INNER JOIN vtiger_crmentity ON vtiger_crmentity.crmid=vtiger_slots.slotsid  
    LEFT JOIN vtiger_bodegas ON vtiger_bodegas.bodegasid=vtiger_slots.slots_tks_bodega
    LEFT JOIN vtiger_racks ON vtiger_racks.racksid=vtiger_slots.slots_tks_rack
    LEFT JOIN vtiger_secciones ON vtiger_secciones.seccionesid=vtiger_slots.slots_tks_seccion
    WHERE deleted='0' AND slots_tks_codigo='$slotID'");
    $dataslots=mysqli_fetch_array($query);  
    $data= mysqli_num_rows($query);    
    //echo $slotID."--".$data;  
    $slotid=$dataslots['crmid'];
    $bodega=$dataslots['bodegas_tks_nombre'];
    $rack=$dataslots['racks_tks_rack'];
    $seccion=$dataslots['secciones_tks_seccion'];
    $slotcodigo=$dataslots['slots_tks_codigo'];


    $query=mysqli_query($link,"SELECT * 
                        FROM vtiger_assets 
                        INNER JOIN vtiger_crmentity ON vtiger_crmentity.crmid=vtiger_assets.assetsid    
                        INNER JOIN vtiger_products ON vtiger_assets.product=vtiger_products.productid    
                        WHERE serialnumber='$serieBI' AND deleted='0'");
    $dataasset=mysqli_fetch_array($query);    
    $assetsid=$dataasset['crmid'];
    $productname=$dataasset['productname'];


    //echo $slotid."--".$assetsid."--".$productname."<br>";
    //echo $bodega."--".$rack."--".$seccion."--".$slotcodigo."<br>";

    $query=mysqli_query($link,"SELECT *FROM vtiger_crmentityrel WHERE relcrmid='$assetsid' AND module='Slots'");
    $datainfo=mysqli_fetch_array($query);
    $num=mysqli_num_rows($query);
    //echo "NUM: ".$num;
    if($num==0){
        //echo "El equipo no esta asociado a ningun slot";
        //Creando relacion del equipo con el asset
        mysqli_query($link,"INSERT INTO vtiger_crmentityrel VALUES ('$slotid','Slots','$assetsid','Assets')");        

        //Actualizando info del equipo        
        mysqli_query($link,"UPDATE vtiger_assetscf SET ".$BodAsset."='$bodega', ".$cantasset."='$qty', ".$SlotAsset."='$slotcodigo',".$SeccAsset."='$seccion',".$RackAsset."='$rack' WHERE assetsid='$assetsid'");
    }else{
        $slotold=$datainfo['crmid'];
        //echo "<br>slotold: ".$slotold."<br>";
        //echo "EL equipo esta en el Slot ".$slotold."<br>";

        //eliminando relacion del equipo con el slot;
        mysqli_query($link,"DELETE FROM vtiger_crmentityrel WHERE crmid='$slotold' AND relcrmid='$assetsid'");

        //Creando nueva relacion
        mysqli_query($link,"INSERT INTO vtiger_crmentityrel VALUES ('$slotid','Slots','$assetsid','Assets')");

        //Actualizando info del equipo        
        mysqli_query($link,"UPDATE vtiger_assetscf SET ".$BodAsset."='$bodega', ".$cantasset."='$qty', ".$SlotAsset."='$slotcodigo',".$SeccAsset."='$seccion',".$RackAsset."='$rack' WHERE assetsid='$assetsid'");
    }
 
    $includenat=includenative($usuario,$password,$url);    
    chdir($includenat);   
    include_once 'vtwsclib/Vtiger/WSClient.php';
    $userws=diccionario($url,'userws');
    $passws=diccionario($url,'keyws');
    $user = $userws;
    $key  = $passws;
    $url  = $url;    
    $client = new Vtiger_WSClient($url);
    $login = $client->doLogin($user, $key);
    if(!$login) {
        $docs[0]=array('Result'=>'0', 'id'=>$recordid);
    }else {    
        $assetid="28x".$assetsid;
        $slotid=diccionario($url,"Slots").$slotid;
        $record=$client->doCreate('Movimientos',array('movimientos_tks_tipo'=>'Reubicacion','movimientos_tks_cantidad'=>$qty,'movimientos_tks_slot'=>$slotid,'movimientos_tks_producto'=>$productname,'assigned_user_id'=>$asignado,$MovAsset=>$assetid));                
            if ($record) {
                $recordid = $client->getRecordId($record['id']);                        
                //Crea relacion de base instalada y movimiento
                mysqli_query($link,"INSERT INTO vtiger_crmentityrel VALUES ('$recordid','Movimientos','$assetsid','Assets')");
                $docs[0]=array('Result'=>'1', 'id'=>$recordid);
            }else{
                $recordid=$client->lastError();
                $docs[0]=array('Result'=>'0', 'id'=>$recordid);                
            }
    }   
echo json_encode(setDataJSON($docs,1));
}
?>
